unit uRunTime;
{ This DataModule contains all the basic functions of the Camel language }
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  LangValMessages,CompEd, StdCtrls, Compiler, RXSplit, Grids, Outline,
  ExtCtrls,Buttons, uObjVM, ObjVM, LangValue, VisualValue, LangProc, ProxyValue, IniFiles,
  Menus,Registry, ComCtrls;

type
  TRunTime = class(TDataModule)
    VM: TObjVM;
    CaptionP: TLangProc;
    RunP: TLangProc;
    CreateDirP: TLangProc;
    CopyFileP: TLangProc;
    ShowP: TLangProc;
    MoveFileP: TLangProc;
    WriteToIniP: TLangProc;
    CreateFileP: TLangProc;
    InputQueryP: TLangProc;
    ReadFromIniP: TLangProc;
    DeleteFileP: TLangProc;
    DeleteDirP: TLangProc;
    RenameFileP: TLangProc;
    WriteToRegistryP: TLangProc;
    GetFileSizeP: TLangProc;
    GetWinTypeP: TLangProc;
    GetCpuTypeP: TLangProc;
    GetUserNameP: TLangProc;
    GetWinDirP: TLangProc;
    GetTotalMemP: TLangProc;
    GetAvailableMemP: TLangProc;
    procedure CaptionPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure RunPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure CreateDirPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure CopyFilePExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure ShowPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure MoveFilePExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure WriteToIniPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure CreateFilePExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure InputQueryPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure ReadFromIniPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure DeleteFilePExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure DeleteDirPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure RenameFilePExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure WriteToRegistryPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure GetFileSizePExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure GetWinTypePExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure GetCpuTypePExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure GetUserNamePExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure GetWinDirPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure GetTotalMemPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure GetAvailableMemPExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RunTime: TRunTime;

implementation
uses VarLangValue, Main, FMXUtils;
{$R *.DFM}

procedure TRunTime.CaptionPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
  Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then MainForm.Caption:=str;    // The form caption change: Example: Caption('The CAMEL language v0.00a');
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=MainForm.Caption;
              S.Push(Res);
            end;
          end;


procedure TRunTime.RunPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then ExecuteFile(str,'',ExtractFilePath(str),SW_Show);
        // Run a file: Example: Run('c:\windows\notepad.exe');
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=MainForm.Caption;
              S.Push(Res);
            end;
          end;

procedure TRunTime.CreateDirPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
           if s.FrameCount<>0 then
           begin
           MakeDir(str);
    // Create a directory: Example: CreateDir('c:\Test');
           end;
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=MainForm.Caption;
              S.Push(Res);
            end;
          end;


procedure TRunTime.CopyFilePExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
   Var SDest,sFrom:string;
       aResult:boolean;
       iDest,iFRom:integer;
       vResult:ILangValue;
          begin
            SDest:='';
            sFrom:='';
            iFrom:=-1;
            iDest:=-1;
            case s.FrameCount of
              1:begin
                 iDest:=0;
                end;
              2:begin
                 iFrom:=0;
                 iDest:=1;
                end;
            end;
            if iDest<>-1 then
            begin
              sDest:=s.FrameValues[iDest].AsString;
            end;
            if iFrom<>-1 then
            begin
              SFrom:=s.FrameValues[iFrom].AsString;
            end;
            CopyFile(sFrom,sDest);
            s.DropFrame;
            aResult:= true;
          // Copy a file: example: CopyFile('c:\aaa.txt','c:\windows');
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;


procedure TRunTime.ShowPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsBoolean:=true;
              S.Push(Res);
            end;
            MessageDlg(str,mtInformation,[mbOk],0);
       // Show a message: example: Show('This is a test');
          end;

procedure TRunTime.MoveFilePExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var SDest,sFrom:string;
              aResult:boolean;
              iDest,iFRom:integer;
              vResult:ILangValue;
          begin
            SDest:='';
            sFrom:='';
            iFrom:=-1;
            iDest:=-1;
            case s.FrameCount of
              1:begin
                 iDest:=0;
                end;
              2:begin
                 iFrom:=0;
                 iDest:=1;
                end;
            end;
            if iDest<>-1 then
            begin
              sDest:=s.FrameValues[iDest].AsString;
            end;
            if iFrom<>-1 then
            begin
              SFrom:=s.FrameValues[iFrom].AsString;
            end;
            s.DropFrame;
            aResult:= true;
              MoveFile(SFrom,sDest);
        // Move a file: example: MoveFile('c:\readme.txt','c:\Myfiles');

            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;


procedure TRunTime.WriteToIniPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sIniName,sSection,sName,SValue:string;
              aResult:boolean;
              iIniName,iSection,iName,iValue:integer;
              vValueRef,vResult:ILangValue;
     IniFile: TIniFile;
          begin
            sIniName:='';
            sSection:='';
            sName:='';
            sValue:='';

            iIniName:=-1;
            iSection:=-1;
            iName:=-1;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
              2:begin
                  iName:=0;
                  iValue:=1;
                end;
              3:begin
                  iSection:=0;
                  iName:=1;
                  iValue:=2;
                end;
              4:begin
                  iIniName:=0;
                  iSection:=1;
                  iName:=2;
                  iValue:=3;
                end;
            end;
            if iValue<>-1 then
            begin
              sValue:=s.FrameValues[iValue].AsString;
            end;
            if iName<>-1 then
            begin
              sName:=s.FrameValues[iName].AsString;
            end;
            if iSection<>-1 then
            begin
              sSection:=s.FrameValues[iSection].AsString;
            end;
            if iIniName<>-1 then
            begin
              sIniName:=s.FrameValues[iIniName].AsString;
            end;
            s.DropFrame;
            IniFile := TIniFile.Create(sIniName);
            aResult:= true;
            IniFile.WriteString(sSection,sName,sValue);
     // Inifiles handling: Example: WriteToIni('c:\a.ini','Section','Name','Value');
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;

procedure TRunTime.CreateFilePExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var I, FileHandler:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then
            begin
            FileHandler:=  FileCreate(str);
            FileClose(FileHandler);
            end;
        // Create a file: Example: CreateFile('c:\readme.txt');
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=MainForm.Caption;
              S.Push(Res);
            end;
          end;


procedure TRunTime.InputQueryPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sCaption,sPrompt,sValue:string;
              aResult:boolean;
              iCaption,iPrompt,iValue:integer;
              vValueRef,vValue,vResult:ILangValue;
          begin
            sCaption:='';
            sPrompt:='';
            sValue:='';
            vValueRef:=nil;
            iCaption:=-1;
            iPrompt:=-1;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
              2:begin
                  iPrompt:=0;
                  iValue:=1;
                end;
              3:begin
                  iCaption:=0;
                  iPrompt:=1;
                  iValue:=2;
                end;
            end;
            if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;
            if iPrompt<>-1 then
            begin
              sPrompt:=s.FrameValues[iPrompt].AsString;
            end;
            if iCaption<>-1 then
            begin
              sCaption:=s.FrameValues[iCaption].AsString;
            end;
            s.DropFrame;
            aResult:=InputQuery(sCaption,sPrompt,sValue);
           // Input Query: Example: a:= 'Tada!';
           //                       InputQuery('A word?','Write something',a.Ref);
           // Don't forget the .Ref with the R in uppercase!
            if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;


procedure TRunTime.ReadFromIniPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sIniName,sSection,sName,SValue:string;
              aResult:boolean;
              iIniName,iSection,iName,iValue:integer;
              vValueRef,vValue,vResult:ILangValue;
     IniFile: TIniFile;
          begin
            sIniName:='';
            sSection:='';
            sName:='';
            sValue:='';
            vValueRef:=nil;
            iIniName:=-1;
            iSection:=-1;
            iName:=-1;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
              2:begin
                  iName:=0;
                  iValue:=1;
                end;
              3:begin
                  iSection:=0;
                  iName:=1;
                  iValue:=2;
                end;
              4:begin
                  iIniName:=0;
                  iSection:=1;
                  iName:=2;
                  iValue:=3;
                end;
            end;
         if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;

            if iName<>-1 then
            begin
              sName:=s.FrameValues[iName].AsString;
            end;
            if iSection<>-1 then
            begin
              sSection:=s.FrameValues[iSection].AsString;
            end;
            if iIniName<>-1 then
            begin
              sIniName:=s.FrameValues[iIniName].AsString;
            end;
           s.DropFrame;
           aResult:= true;
           IniFile.Create(sIniName);
           sValue:=IniFile.ReadString(sSection,sName,sValue);

           if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;


procedure TRunTime.DeleteFilePExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then DeleteFile(str);
            // Delete a file: Example: Delete('c:\aaa.txt');
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=MainForm.Caption;
              S.Push(Res);
            end;
          end;

procedure TRunTime.DeleteDirPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then DeleteDir(str);
            // Delete a file: Example: DeleteDir('c:\aaa.txt');
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=MainForm.Caption;
              S.Push(Res);
            end;
          end;

procedure TRunTime.RenameFilePExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var SDest,sFrom:string;
              aResult:boolean;
              iDest,iFRom:integer;
              vResult:ILangValue;
          begin
            SDest:='';
            sFrom:='';
            iFrom:=-1;
            iDest:=-1;
            case s.FrameCount of
              1:begin
                 iDest:=0;
                end;
              2:begin
                 iFrom:=0;
                 iDest:=1;
                end;
            end;
            if iDest<>-1 then
            begin
              sDest:=s.FrameValues[iDest].AsString;
            end;
            if iFrom<>-1 then
            begin
              SFrom:=s.FrameValues[iFrom].AsString;
            end;
            s.DropFrame;
            aResult:= true;
            RenameFile(sFrom, sDest);
          // Rename a file: example: RenameFile('c:\aaa.txt','c:\bbb.txt');
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;


procedure TRunTime.WriteToRegistryPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var           sHkey,sPath,sKey,sValue:string;
              aResult:boolean;
              iHKey,iPath,iKey,iValue:integer;
              vValueRef,vResult:ILangValue;
              Registry: TRegistry;
          begin
            sHkey:='';
            sPath:='';
            sKey:='';
            sValue:='';
          
            iHkey:=-1;
            iPath:=-1;
            iKey:=-1;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
              2:begin
                  iKey:=0;
                  iValue:=1;
                end;
              3:begin
                  iPath:=0;
                  iKey:=1;
                  iValue:=2;
                end;
              4:begin
                  iHkey:=0;
                  iPath:=1;
                  iKey:=2;
                  iValue:=3;
                end;
            end;
            if iValue<>-1 then
            begin
              sValue:=s.FrameValues[iValue].AsString;
            end;
            if iKey<>-1 then
            begin
              sKey:=s.FrameValues[iKey].AsString;
            end;
            if iPath<>-1 then
            begin
              sPath:=s.FrameValues[iPath].AsString;
            end;
            if iHkey<>-1 then
            begin
              sHkey:=s.FrameValues[iHkey].AsString;
            end;
            s.DropFrame;
            aResult:= true;

            if sHkey='Hkey_Classes_Root' then
            Registry.RootKey:=Hkey_Classes_Root
           else if sHkey='Hkey_Current_User' then
            Registry.RootKey:=Hkey_Current_User
           else if sHkey='Hkey_Local_Machine' then
            Registry.RootKey:=Hkey_Local_Machine
           else if sHkey='Hkey_Users' then
            Registry.RootKey:=Hkey_Users
           else if sHkey='Hkey_Current_Config' then
            Registry.RootKey:=Hkey_Current_Config
           else if sHkey='Hkey_Dyn_Data' then
            Registry.RootKey:=Hkey_Dyn_Data
           else ShowMessage('Root Key doesn''t exists');

            Registry.WriteString(SPath+'\'+sKey,SValue);
            // This generate an Access violation. Please take a look at it to know why

            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;

procedure TRunTime.GetFileSizePExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sFile,sValue:string;
    aResult:boolean;
    iFile,iValue:integer;
    vValueRef,vValue,vResult:ILangValue;
          begin
            sFile:='';
            sValue:='';
            vValueRef:=nil;
            iFile:=-1;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
              2:begin
                  iFile:=0;
                  iValue:=1;
                end;
            end;
            if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;
             if iFile<>-1 then
            begin
              sFile:=s.FrameValues[iFile].AsString;
            end;

            s.DropFrame;
            aResult:= true;
            sValue:=(IntToStr(GetFileSize(sFile)));
{            Get the size of the specified file. Example:
            Val:='';
            GetFileSize('c:\test.ini',Val.Ref);
            Show('c:\test.ini is ' + Val + ' octets large');

            Don't forget the .Ref with the R in uppercase! }
            if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;


procedure TRunTime.GetWinTypePExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sValue:string;
    aResult:boolean;
    iValue:integer;
    vValueRef,vValue,vResult:ILangValue;
    OS: TOSVersionInfo;
          begin
            sValue:='';
            vValueRef:=nil;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
            end;
            if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;

            s.DropFrame;
            aResult:= true;
            sValue:=GetWinVersion(Os);
{           Get the windows version. Example:
            Version:='';
            GetWinVersion(Version.Ref);
            Show(Version);

            Don't forget the .Ref with the R in uppercase! }

            if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;

procedure TRunTime.GetCpuTypePExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sValue:string;
    aResult:boolean;
    iValue:integer;
    vValueRef,vValue,vResult:ILangValue;
    SI: TSystemInfo;
          begin
            sValue:='';
            vValueRef:=nil;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
            end;
            if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;

            s.DropFrame;
            aResult:= true;
            sValue:=GetCpuType(SI);
{           Get the computer type. Example:
            Type:='';
            GetCpuType(Type.Ref);
            Show(Type);

            Don't forget the .Ref with the R in uppercase! }

            if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;


procedure TRunTime.GetUserNamePExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sValue:string;
    aResult:boolean;
    iValue:integer;
    vValueRef,vValue,vResult:ILangValue;
    PathArray : array [0..255] of char;
    di: longint;
          begin
            sValue:='';
            vValueRef:=nil;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
            end;
            if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;

            s.DropFrame;
            aResult:= true;
            FillChar(PathArray, SizeOf(PathArray), #0);
            di := 255;
            GetUserName(PathArray,dword(di));
            sValue:= Format('%s',[PathArray]);
            
{           Get the user name. Example:
            Name:='';
            GetUserName(Name.Ref);
            Show(Name);
            Don't forget the .Ref with the R in uppercase! }

            if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;

procedure TRunTime.GetWinDirPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sValue:string;
    aResult:boolean;
    iValue:integer;
    vValueRef,vValue,vResult:ILangValue;
    PathArray : array [0..255] of char;
          begin
            sValue:='';
            vValueRef:=nil;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
            end;
            if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;

            s.DropFrame;
            aResult:= true;
            FillChar(PathArray, SizeOf(PathArray), #0);
            GetWindowsDirectory(PathArray,255);
            sValue:= Format('%s',[PathArray]);
            
{           Get the user name. Example:
            WinDir:='';
            GetWinDir(WinDir.Ref);
            Show(WinDir);

            Don't forget the .Ref with the R in uppercase! }

            if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;

procedure TRunTime.GetTotalMemPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sValue:string;
    aResult:boolean;
    iValue:integer;
    vValueRef,vValue,vResult:ILangValue;
    MemStat : TMemoryStatus;
          begin
            sValue:='';
            vValueRef:=nil;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
            end;
            if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;

            s.DropFrame;
            aResult:= true;
            sValue:=GetTotalMem(MemStat);
{           Get the total memory. Example:
            Mem:='';
            GetTotalMem(Mem.Ref);
            Show(Mem + ' Kb');

            Don't forget the .Ref with the R in uppercase! }

            if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;


procedure TRunTime.GetAvailableMemPExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sValue:string;
    aResult:boolean;
    iValue:integer;
    vValueRef,vValue,vResult:ILangValue;
    MemStat : TMemoryStatus;
          begin
            sValue:='';
            vValueRef:=nil;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
            end;
            if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;

            s.DropFrame;
            aResult:= true;
            sValue:=GetAvailableMem(MemStat);
{           Get the available memory. Example:
            Mem:='';
            GetAvailableMem(Mem.Ref);
            Show(Mem + ' Kb');

            Don't forget the .Ref with the R in uppercase! }

            if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;

end.
